Summary: 	The J programming language
Name: 		j
Version:	9.01
Release:	2%{?dist}
License:	GPL
URL:		https://www.jsoftware.com/
Source0:	https://github.com/jsoftware/jsource/archive/j901-release-e.tar.gz
%if "%{rhel}" == "6"
BuildRequires:	devtoolset-8-toolchain
%endif
BuildRequires:	gcc

%description
This is an unofficial community build of J. As such, binary
upgrades shouldn't be pulled from normal sources, and the
package manager should be used with some care. A command like

  load 'pacman'
  'install' jpkg '*'

for example will update the JQt library from offical sources
and potentially break your install. In a pinch you can
reinstall this package (sudo dnf reinstall j, or the same
command with yum) to correct such problems.

You can avoid the special treatment of '*' and install all
packages by using shownotinstalled. I recommend these
post-install actions:

$ sudo /usr/bin/ijconsole
   load 'pacman'
   'install' jpkg 'base library'
   exit 0

and then:

$ sudo /usr/bin/ijconsole
   load 'pacman'
   'install' jpkg {."1 'shownotinstalled' jpkg ''

%prep
tar zxvf %{_sourcedir}/j901-release-e.tar.gz
ln -sf jsource-j901-release-e jsource

%build
cd %{_builddir}/jsource-j901-release-e
%if "%{rhel}" == "6"
echo '( cd make2; ./build_all.sh )' scl enable devtoolset-8 bash
%else
( cd make2; ./build_all.sh )
%endif

%install
cd %{_builddir}/jsource-j901-release-e
mkdir -p %{buildroot}/usr/share/j/%{version}/{addons/ide,addons/ide/jhs,system,tools,icons}
mkdir -p %{buildroot}/etc/j/%{version}
mkdir -p %{buildroot}/usr/bin/
mkdir -p %{buildroot}/usr/lib64
mkdir -p %{buildroot}/usr/share/licenses/j
cp -r jlibrary/system %{buildroot}/usr/share/j/%{version}/.
cp -r jlibrary/tools %{buildroot}/usr/share/j/%{version}/.
#cp -r jlibrary/icons %{buildroot}/usr/share/j/%{version}/.
cp -r jlibrary/addons %{buildroot}/usr/share/j/%{version}/.
cp jlibrary/bin/profile.ijs %{buildroot}/etc/j/%{version}/.
find %{buildroot}/usr/share/j/%{version} -type d -exec chmod a+rx {} +
find %{buildroot}/usr/share/j/%{version} -type f -exec chmod a+r {} +
find %{buildroot}/etc/j/%{version} -type d -exec chmod a+rx {} \+
find %{buildroot}/etc/j/%{version} -type f -exec chmod a+r {} \+
echo '#!/bin/bash' > %{buildroot}/usr/bin/ijconsole.sh
echo "cd ~ && /usr/bin/ijconsole \"$@\"" >> %{buildroot}/usr/bin/ijconsole.sh
chmod 755 %{buildroot}/usr/bin/ijconsole.sh
cp bin/linux/j64avx/jconsole %{buildroot}/usr/bin/ijconsole-%{version}
chmod 755 %{buildroot}/usr/bin/ijconsole-%{version}
(cd %{buildroot}/usr/bin && ln -sf ijconsole-%{version} ijconsole)
install -m 755 bin/linux/j64avx/libj.so %{buildroot}/usr/lib64/libj.so.%{version}
install -m 755 bin/linux/j64avx/libtsdll.so %{buildroot}/usr/lib64/libtsdll.so.%{version}
install -m 755 bin/linux/j64avx/libj.so %{buildroot}/usr/lib64/libj.so
install -m 755 bin/linux/j64avx/libtsdll.so %{buildroot}/usr/lib64/libtsdll.so
install -m 644 license.txt %{buildroot}/usr/share/licenses/j/license.txt

%files
/usr/share/licenses/j/license.txt
/usr/bin/ijconsole.sh
/usr/bin/ijconsole-%{version}
/usr/bin/ijconsole
/usr/lib64/libj.so.%{version}
/usr/lib64/libtsdll.so.%{version}
/etc/j/9.01/profile.ijs
/usr/lib64/libj.so
/usr/lib64/libtsdll.so
/usr/share/j

%post
#/usr/bin/ijconsole -js "exit 'install' jpkg 'base library' [ load 'pacman'"
#/usr/bin/ijconsole -js "exit 'install' jpkg 'install'jpkg {.\"1'shownotinstalled'jpkg''[ load 'pacman'"

%changelog
* Thu Mar 05 2020 Julian Fondren <jfondren@minimaltype.com> - 9.01-2
- Require higher version of GCC for CentOS 6 build.

* Wed Mar 04 2020 Julian Fondren <jfondren@minimaltype.com> - 9.01-1
- Initial COPR packaging.
